//用户进入（加载页面的时间）
let enterTime = new Date();
//用户在页面上的停留时间
let stayTime = 0;

//定时计算用户在页面上的停留时间
setInterval(function () {
    let visibilityState = document.visibilityState == 'hidden' ? 0 : 1;
    if (visibilityState === 1){
        stayTime++;
    }
}, 1000);

//每60s向服务器端发送用户的停留时间
setInterval(function () {
    let now = new Date();
    let runTime = now.getTime() - enterTime.getTime();
    //如果目前时间距页面加载时间不超过2小时且用户在页面停留不超过400s，则记录用户的停留信息
    if(runTime < 7200000 && stayTime < 401){
        recordStayInfo();
    }
}, 60000);

//记录用户在页面上的停留时间
let recordStayInfo = function () {
    let code = $.cookie('pCode');
    $.ajax({
        url :'/tracker/stay?code=' + code +'&stay='+stayTime,
        type :'GET',
    })
}

//当卸载页面时，即触发相应的事件记录用户离开时间
window.onbeforeunload = function () {
    let code = $.cookie('pCode');
    $.ajax({
        url :'/tracker/leave?code=' + code,
        type :'GET',
    })
}

$(function () {
    //当【姓名】发生变更时，记录变更信息
    $('#username').change(function () {
        let value = $('#username').val();
        if(value.trim() != ''){
            addUserOpt('username', value);
        }
    });

    //当【手机】发生变更时，记录变更信息
    $('#phone').change(function () {
        let value = $('#phone').val();
        if(value.trim() != ''){
            addUserOpt('phone', value);
        }
    });


    //当【查询订单】发生变更时，记录变更信息
    $('#phone2').change(function () {
        let value = $('#phone2').val();
        if(value.trim() != ''){
            addUserOpt('search', value);
        }
    });

    //当【详细地址】发生变更时，记录变更信息
    $('#address').change(function () {
        let value = $('#address').val();
        if(value.trim() != ''){
            addUserOpt('address', value);
        }
    });

    //当【邮编】发生变更时，记录变更信息
    $('#zipCode').change(function () {
        let value = $('#zipCode').val();
        if(value.trim() != ''){
            addUserOpt('zipCode', value);
        }
    });

    //当【邮箱】发生变更时，记录变更信息
    $('#email').change(function () {
        let value = $('#email').val();
        if(value.trim() != ''){
            addUserOpt('email', value);
        }
    });

    //当【留言】发生变更时，记录变更信息
    $('#message').change(function () {
        let value = $('#message').val();
        if(value.trim() != ''){
            addUserOpt('message', value);
        }
    });
});

/**
 * 添加用户操作记录
 * @param name
 * @param content
 */
function addUserOpt (name, content) {
    let req = {};
    req.code = $.cookie('pCode');
    req.name = name;
    req.content = content.trim();
    req.time = new Date();
    $.ajax({
        url: '/tracker',
        method: 'POST',
        dataType: 'json',
        contentType: 'application/json',
        data:JSON.stringify(req),
    })
}